package com.cch_lab.android.apply.prototype.tinybasic.command;


import com.cch_lab.android.apply.prototype.tinybasic.token.AbstractToken;

/**
 * 二項演算情報・クラス.
 * <p>
 *     二項演算の左辺値と右辺値および演算子トークンを保管するクラスです。
 * </p>
 */
public class BinaryOperatorInformation {
    public final AbstractToken operator;
    public final Object leftValue;
    public final Object rightValue;

    /**
     * コンストラクタ.
     * @param operator   演算子トークン
     * @param leftValue  左辺値
     * @param rightValue 右辺値
     */
    public BinaryOperatorInformation(AbstractToken operator, Object leftValue, Object rightValue){
        this.operator   = operator;
        this.leftValue  = leftValue;
        this.rightValue = rightValue;
    }
}
