package com.cch_lab.android.apply.prototype.tinybasic.command;

import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxTreeStream;

import java.util.ArrayList;
import java.util.List;


/**
 * コマンド・ストリーム.
 * <p>
 *     コマンドのストリームを表すクラスです。
 * </p>
 */
public class CommandStream {
    private List<AbstractCommand> commandStream;
//    private SyntaxTreeStream syntaxTreeStream;

    /**
     * コンストラクタ.
     * @param syntaxTreeStream 構文木ストリーム
     */
    public CommandStream(SyntaxTreeStream syntaxTreeStream) {
        this.commandStream = new ArrayList<>();
//        this.syntaxTreeStream = syntaxTreeStream;
    }

//    /**
//     * 構文木ストリーム取得.
//     * @return 構文木ストリーム
//     */
//    public SyntaxTreeStream getSyntaxTreeStream() {
//        return syntaxTreeStream;
//    }

    /**
     * コマンド取得.
     * @param index 取得位置インデックス
     * @return コマンド
     */
    public AbstractCommand getCommand(int index) {
        return commandStream.get(index);
    }

//    /**
//     * コマンド位置インデックス取得.
//     * @param command コマンド
//     * @return コマンド位置インデックス
//     */
//    public int getIndex(AbstractCommand command) {
//        int index = commandStream.indexOf(command);
//        if (command == null) return index;
//
//        if (index == -1) {
//            // コマンドは、syntaxTreeを元に生成されるため中身のチェックを行う
//            for (int i = 0; i < commandStream.size(); i++) {
//                if (command.getParameterSyntaxTree()
//                        .equals(commandStream.get(i).getParameterSyntaxTree())) {
//                    index = i;
//                    break;
//                }
//            }
//        }
//        return index;
//    }

    /**
     * コマンド個数取得.
     * @return コマンド個数
     */
    public int size() {
        return commandStream.size();
    }


    /**
     * コマンド追加.
     * @param command 追加コマンド
     */
    void add(AbstractCommand command) {
        commandStream.add(size(), command);
    }

//    /**
//     * コマンド追加.
//     * @param index   追加位置
//     * @param command 追加コマンド
//     */
//    void add(int index, AbstractCommand command) {
//        commandStream.add(index, command);
//    }
//
//    /**
//     * コマンド追加.
//     * @param index    追加位置
//     * @param commands 追加コマンド
//     */
//    void add(int index, AbstractCommand ...commands) {
//        for (int commandIndex = 0; commandIndex < commands.length; commandIndex++) {
//            commandStream.add(index + commandIndex, commands[commandIndex]);
//        }
//    }
//
//    /**
//     * コマンド削除.
//     * @param index 削除位置
//     */
//    void remove(int index) {
//        commandStream.remove(index);
//    }
//
//    /**
//     * コマンド削除.
//     * @param start 削除開始位置
//     * @param end   削除終了位置
//     */
//    void remove(int start, int end) {
//        for (int index = start; index <= end; index++) {
//            commandStream.remove(index);
//        }
//    }
//
//    /**
//     * コマンド置換.
//     * @param index   置換位置
//     * @param command 置換コマンド
//     * @return 相対位置 (置換後の元位置からの相対位置を返します)
//     */
//    int replace(int index, AbstractCommand command) {
//        commandStream.set(index, command);
//        return 0;
//    }
}
