package com.cch_lab.android.apply.prototype.tinybasic.command;


/**
 * 値・クラス.
 * <p>
 *     値と型を保管するクラスです。
 * </p>
 */
public class Value {
    final Class<?> type;
    Object value;

    /**
     * コンストラクタ.
     * @param type 値型
     */
    Value(Class<?> type){
        this.type  = type;
        this.value = null;
    }

    /**
     * 値取得.
     * @return 値 (取得先で型キャストが必要)
     */
    public Object getValue() {
        return this.value;
    }

    /**
     * 値設定.
     * @param value 値
     */
    public void setValue(Object value) {
        this.value = value;
    }
}
