package com.cch_lab.android.apply.prototype.tinybasic.command.item;

import com.cch_lab.android.apply.prototype.tinybasic.command.*;
import com.cch_lab.android.apply.prototype.tinybasic.command.Void;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxTree;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.Assignment;


/**
 * 代入演算・コマンド.
 * <p>
 *     代入演算を表すコマンドです。
 * </p>
 */
public class AssignmentCommand extends AbstractCommand {

    /**
     *{@inheritDoc}
     */
    @Override
    public Class<? extends AbstractSyntax>[] getSupportSyntax() {
        Class[] patterns =
                    new Class[]{
                        Assignment.class,
                    };
        return (Class<? extends AbstractSyntax>[]) patterns;
    }

    /**
     *{@inheritDoc}
     */
    @Override
    public Object evaluate(
            CommandRuntimeEnvironment runtime,
            Object leftLeafResult, Object middleLeafResult, Object rightLeafResult) {

        // 対応構文ノード取得
        SyntaxTree node = getParameterSyntaxTree();

        // 型宣言変数名取得
        String name = (String)leftLeafResult;

        // 演算結果設定
        runtime.setVariableValue(name, rightLeafResult, node.getLeftLeaf().getMiddleToken());

        return new Void();
    }
}
