package com.cch_lab.android.apply.prototype.tinybasic.command.item;

import com.cch_lab.android.apply.prototype.tinybasic.command.AbstractCommand;
import com.cch_lab.android.apply.prototype.tinybasic.command.CommandRuntimeEnvironment;
import com.cch_lab.android.apply.prototype.tinybasic.command.Void;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxTree;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.BuiltInFunction;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.InputFunction;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.PrintFunction;

import java.io.IOException;


/**
 * 組込関数・コマンド.
 * <p>
 *     組込関数を表すコマンドです。
 * </p>
 */
public class BuiltInFunctionCommand extends AbstractCommand {

    /**
     *{@inheritDoc}
     */
    @Override
    public Class<? extends AbstractSyntax>[] getSupportSyntax() {
        Class[] patterns =
                    new Class[]{
                        BuiltInFunction.class
                    };
        return (Class<? extends AbstractSyntax>[]) patterns;
    }

    /**
     *{@inheritDoc}
     */
    @Override
    public Object evaluate(
            CommandRuntimeEnvironment runtime,
            Object leftLeafResult, Object middleLeafResult, Object rightLeafResult) {

        // 対応構文ノード取得
        SyntaxTree node = getParameterSyntaxTree();

        // 関数評価結果返却
        return middleLeafResult;
    }
}
