package com.cch_lab.android.apply.prototype.tinybasic.command.item;

import com.cch_lab.android.apply.prototype.tinybasic.command.AbstractCommand;
import com.cch_lab.android.apply.prototype.tinybasic.command.CommandRuntimeEnvironment;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.DefineStringVariable;


/**
 * 文字列型変数宣言・コマンド.
 * <p>
 *     文字列型の変数宣言を表すコマンドです。
 * </p>
 */
public class DefineStringVariableCommand extends AbstractCommand {

    /**
     *{@inheritDoc}
     */
    @Override
    public Class<? extends AbstractSyntax>[] getSupportSyntax() {
        Class[] patterns =
                    new Class[]{
                        DefineStringVariable.class,
                    };
        return (Class<? extends AbstractSyntax>[]) patterns;
    }

    /**
     *{@inheritDoc}
     */
    @Override
    public Object evaluate(
            CommandRuntimeEnvironment runtime,
            Object leftLeafResult, Object middleLeafResult, Object rightLeafResult) {

        // 変数名取得
        String name = (String)rightLeafResult;

        // 変数宣言
        runtime.defineVariable(name, String.class, getParameterSyntaxTree().getRightLeaf().getMiddleToken());

        // 変数名返却
        return name;
    }
}
