package com.cch_lab.android.apply.prototype.tinybasic.command.item;

import com.cch_lab.android.apply.prototype.tinybasic.command.AbstractCommand;
import com.cch_lab.android.apply.prototype.tinybasic.command.CommandRuntimeEnvironment;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxTree;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.InputKeyword;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.IntegerKeyword;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.PrintKeyword;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.StringKeyword;


/**
 * キーワード・コマンド.
 * <p>
 *     キーワードを表すコマンドです。
 * </p>
 */
public class KeywordCommand extends AbstractCommand {

    /**
     *{@inheritDoc}
     */
    @Override
    public Class<? extends AbstractSyntax>[] getSupportSyntax() {
        Class[] patterns =
                    new Class[]{
                        StringKeyword.class,
                        IntegerKeyword.class,
                        InputKeyword.class,
                        PrintKeyword.class
                    };
        return (Class<? extends AbstractSyntax>[]) patterns;
    }

    /**
     *{@inheritDoc}
     */
    @Override
    public Object evaluate(
            CommandRuntimeEnvironment runtime,
            Object leftLeafResult, Object middleLeafResult, Object rightLeafResult) {

        // 対応構文ノードとトークン＆構文取得
        SyntaxTree node = getParameterSyntaxTree();

        // キーワード名返却
        return node.getMiddleToken().getTokenSource().getSource();
    }
}
