package com.cch_lab.android.apply.prototype.tinybasic.command.item;

import com.cch_lab.android.apply.prototype.tinybasic.command.AbstractCommand;
import com.cch_lab.android.apply.prototype.tinybasic.command.BinaryOperatorInformation;
import com.cch_lab.android.apply.prototype.tinybasic.command.CommandRuntimeEnvironment;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxTree;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.LeftParenthesesBinaryOperator;
import com.cch_lab.android.apply.prototype.tinybasic.token.AbstractToken;


/**
 * (左丸括弧第一次)二項演算・構文木.
 * <p>
 *     (左丸括弧第一次)二項演算を表すコマンドです。
 * </p>
 */
public class LeftParenthesesBinaryOperationCommand extends AbstractCommand {

    /**
     *{@inheritDoc}
     */
    @Override
    public Class<? extends AbstractSyntax>[] getSupportSyntax() {
        Class[] patterns =
                    new Class[]{
                            LeftParenthesesBinaryOperator.class
                    };
        return (Class<? extends AbstractSyntax>[]) patterns;
    }

    /**
     *{@inheritDoc}
     */
    @Override
    public Object evaluate(
            CommandRuntimeEnvironment runtime,
            Object leftLeafResult, Object middleLeafResult, Object rightLeafResult) {

        // 対応構文ノードとトークン＆構文取得
        SyntaxTree node = getParameterSyntaxTree();
        AbstractToken operator = node.getMiddleToken();

        // 二項演算情報を返却する
        return new BinaryOperatorInformation(operator, leftLeafResult, null);
    }
}
