package com.cch_lab.android.apply.prototype.tinybasic.command.item;

import com.cch_lab.android.apply.prototype.tinybasic.command.Void;
import com.cch_lab.android.apply.prototype.tinybasic.command.AbstractCommand;
import com.cch_lab.android.apply.prototype.tinybasic.command.CommandRuntimeEnvironment;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.AssignmentStatement;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.AssignmentWithDefineStatement;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.BeginBlockComment;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.BlockComment;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.EndBlockComment;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.ExpressionStatement;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.InputKeyword;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.IntegerKeyword;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.LineComment;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.MiddleBlockComment;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.PrintKeyword;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.Program;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.Statement;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.Statements;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.StringKeyword;


/**
 * 何もしない・コマンド.
 * <p>
 *     何もしない処理(コマンド評価を行わない)を表すコマンドです。
 * </p>
 */
public class NoneCommand extends AbstractCommand {

    /**
     *{@inheritDoc}
     */
    @Override
    public Class<? extends AbstractSyntax>[] getSupportSyntax() {
        Class<?>[] patterns =
                new Class[]{
                    Program.class,
                    Statement.class,
                    Statements.class,

                    AssignmentStatement.class,
                    AssignmentWithDefineStatement.class,
                    ExpressionStatement.class,

                    LineComment.class,
                    BlockComment.class,
                    BeginBlockComment.class,
                    MiddleBlockComment.class,
                    EndBlockComment.class
                };
        return (Class<? extends AbstractSyntax>[])patterns;
    }

    /**
     *{@inheritDoc}
     */
    @Override
    public Object evaluate(
            CommandRuntimeEnvironment runtime,
            Object leftLeafResult, Object middleLeafResult, Object rightLeafResult) {

        // ボイド型を返す。
        return new Void();
    }
}
