package com.cch_lab.android.apply.prototype.tinybasic.command.item;

import com.cch_lab.android.apply.prototype.tinybasic.command.AbstractCommand;
import com.cch_lab.android.apply.prototype.tinybasic.command.BinaryOperatorInformation;
import com.cch_lab.android.apply.prototype.tinybasic.command.CommandRuntimeEnvironment;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.OperationBothParentheses;


/**
 * (両丸括弧)単項演算・構文木.
 * <p>
 *     (両丸括弧)単項演算を表すコマンドです。
 * </p>
 */
public class OperationBothParenthesesCommand extends AbstractCommand {

    /**
     *{@inheritDoc}
     */
    @Override
    public Class<? extends AbstractSyntax>[] getSupportSyntax() {
        Class[] patterns =
                    new Class[]{
                        OperationBothParentheses.class,
                    };
        return (Class<? extends AbstractSyntax>[]) patterns;
    }

    /**
     *{@inheritDoc}
     */
    @Override
    public Object evaluate(
            CommandRuntimeEnvironment runtime,
            Object leftLeafResult, Object middleLeafResult, Object rightLeafResult) {

        // リーフの評価結果を返却
        return middleLeafResult;
    }
}
