package com.cch_lab.android.apply.prototype.tinybasic.command.item;

import com.cch_lab.android.apply.prototype.tinybasic.command.AbstractCommand;
import com.cch_lab.android.apply.prototype.tinybasic.command.BinaryOperatorInformation;
import com.cch_lab.android.apply.prototype.tinybasic.command.CommandRuntimeEnvironment;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxTree;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.OperationRightParentheses;
import com.cch_lab.android.apply.prototype.tinybasic.token.AbstractToken;


/**
 * (左丸括弧)二項演算・構文木.
 * <p>
 *     (左丸括弧)二項演算を表すコマンドです。
 * </p>
 */
public class OperationRightParenthesesCommand extends AbstractCommand {

    /**
     *{@inheritDoc}
     */
    @Override
    public Class<? extends AbstractSyntax>[] getSupportSyntax() {
        Class[] patterns =
                    new Class[]{
                        OperationRightParentheses.class,
                    };
        return (Class<? extends AbstractSyntax>[]) patterns;
    }

    /**
     *{@inheritDoc}
     */
    @Override
    public Object evaluate(
            CommandRuntimeEnvironment runtime,
            Object leftLeafResult, Object middleLeafResult, Object rightLeafResult) {

        // 対応構文ノードとトークン＆構文取得
        SyntaxTree node = getParameterSyntaxTree();
        AbstractToken token = node.getLeftToken();

        // 左辺の二項演算情報を取得
        BinaryOperatorInformation info = (BinaryOperatorInformation)rightLeafResult;

        // 二項演算コマンドと二項演算情報を利用して、演算評価
        return BinaryOperatorCommand.evaluate(runtime, info.operator, middleLeafResult, null, info.rightValue);
    }
}
