package com.cch_lab.android.apply.prototype.tinybasic.command.item;

import com.cch_lab.android.apply.prototype.tinybasic.command.AbstractCommand;
import com.cch_lab.android.apply.prototype.tinybasic.command.CommandRuntimeEnvironment;
import com.cch_lab.android.apply.prototype.tinybasic.command.Void;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxTree;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.PrintFunction;


/**
 * (組込関数)print・コマンド.
 * <p>
 *     (組込関数)printを表すコマンドです。
 * </p>
 */
public class PrintFunctionCommand extends AbstractCommand {

    /**
     *{@inheritDoc}
     */
    @Override
    public Class<? extends AbstractSyntax>[] getSupportSyntax() {
        Class[] patterns =
                    new Class[]{
                        PrintFunction.class,
                    };
        return (Class<? extends AbstractSyntax>[]) patterns;
    }

    /**
     *{@inheritDoc}
     */
    @Override
    public Object evaluate(
            CommandRuntimeEnvironment runtime,
            Object leftLeafResult, Object middleLeafResult, Object rightLeafResult) {

        // 対応構文ノード取得
        SyntaxTree node = getParameterSyntaxTree();

        // 関数名取得 (関数名/キーワード名を取得)
        String functionName = node.getMiddleLeaf().getMiddleToken().getTokenSource().getSource();

        // 関数名に対応するシステム機能を実行
        if("print".equals(functionName)) {
            System.out.println(rightLeafResult.toString());
            return new Void();
        }
        return null;
    }
}
