package com.cch_lab.android.apply.prototype.tinybasic.command.item;

import com.cch_lab.android.apply.prototype.tinybasic.command.AbstractCommand;
import com.cch_lab.android.apply.prototype.tinybasic.command.CommandRuntimeEnvironment;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxTree;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.item.Variable;
import com.cch_lab.android.apply.prototype.tinybasic.token.AbstractToken;


/**
 * 変数名・コマンド.
 * <p>
 *     変数名を表すコマンドです。
 * </p>
 */
public class VariableCommand extends AbstractCommand {

    /**
     *{@inheritDoc}
     */
    @Override
    public Class<? extends AbstractSyntax>[] getSupportSyntax() {
        Class<?>[] patterns =
                new Class[]{
                    Variable.class
                };
        return (Class<? extends AbstractSyntax>[])patterns;
    }

    /**
     *{@inheritDoc}
     */
    @Override
    public Object evaluate(
            CommandRuntimeEnvironment runtime,
            Object leftLeafResult, Object middleLeafResult, Object rightLeafResult) {

        // 変数ノード取得
        SyntaxTree node = getParameterSyntaxTree().getNode();

        // 変数名返却
        return node.getMiddleToken().getTokenSource().getSource();
    }
}
