package com.cch_lab.android.apply.prototype.tinybasic.syntax.item;

import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPattern;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPatterns;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.AssignmentToken;


/**
 * 変数代入・構文木.
 * <p>
 *     変数への代入を表す構文木です。
 * </p>
 */
public class Assignment extends AbstractSyntax {
    /**
     * デフォルト・コンストラクタ.
     */
    public Assignment() {
    }

    @Override
    public SyntaxPatterns getSyntaxPatterns() {
        return new SyntaxPatterns(
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    Variable.class),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    AssignmentToken.class),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    Expression.class)
        );
    }
}
