package com.cch_lab.android.apply.prototype.tinybasic.syntax.item;

import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPattern;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPatterns;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.TerminalOperatorToken;


/**
 * 変数代入文・構文木.
 * <p>
 *     変数への代入文を表す構文木です。
 * </p>
 */
public class AssignmentStatement extends AbstractSyntax {
    /**
     * デフォルト・コンストラクタ.
     */
    public AssignmentStatement() {
    }

    @Override
    public SyntaxPatterns getSyntaxPatterns() {
        return new SyntaxPatterns(
            new SyntaxPattern(SyntaxPattern.Pattern.NONE),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    Assignment.class),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    TerminalOperatorToken.class)
        );
    }
}
