package com.cch_lab.android.apply.prototype.tinybasic.syntax.item;

import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPattern;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPatterns;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.TerminalOperatorToken;


/**
 * (型宣言付)変数代入文・構文木.
 * <p>
 *     型宣言付の変数への代入文を表す構文木です。
 * </p>
 */
public class AssignmentWithDefineStatement extends AbstractSyntax {
    /**
     * デフォルト・コンストラクタ.
     */
    public AssignmentWithDefineStatement() {
    }

    @Override
    public SyntaxPatterns getSyntaxPatterns() {
        return new SyntaxPatterns(
            new SyntaxPattern(SyntaxPattern.Pattern.NONE),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    AssignmentWithDefine.class),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    TerminalOperatorToken.class)
        );
    }
}
