package com.cch_lab.android.apply.prototype.tinybasic.syntax.item;

import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPattern;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPatterns;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.BeginBlockCommentToken;


/**
 * ブロックコメント始端構文木.
 * <p>
 *     ブロックコメント始端を表す構文木です。
 * </p>
 */
public class BeginBlockComment extends AbstractSyntax {
    /**
     * デフォルト・コンストラクタ.
     */
    public BeginBlockComment() {
    }

    @Override
    public SyntaxPatterns getSyntaxPatterns() {
        return new SyntaxPatterns(
            new SyntaxPattern(SyntaxPattern.Pattern.NOT_EXIST,
                    BeginBlockComment.class,
                    MiddleBlockComment.class),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    BeginBlockCommentToken.class),
            new SyntaxPattern(SyntaxPattern.Pattern.NONE)
        );
    }
}
