package com.cch_lab.android.apply.prototype.tinybasic.syntax.item;

import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPattern;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPatterns;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.CloseBracketToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.OpenBracketToken;


/**
 * (空)角括弧構文木.
 * <p>
 *     (空)角括弧を表す構文木です。
 * </p>
 */
public class BlankBracket extends AbstractSyntax {
    /**
     * デフォルト・コンストラクタ.
     */
    public BlankBracket() {
    }

    @Override
    public SyntaxPatterns getSyntaxPatterns() {
        return new SyntaxPatterns(
            new SyntaxPattern(SyntaxPattern.Pattern.NONE),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    OpenBracketToken.class),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    CloseBracketToken.class)
        );
    }
}
