package com.cch_lab.android.apply.prototype.tinybasic.syntax.item;

import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPattern;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPatterns;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.CloseParenthesesToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.OpenParenthesesToken;


/**
 * (空)丸括弧・構文木.
 * <p>
 *     (空)丸括弧を表す構文木です。
 * </p>
 */
public class BlankParentheses extends AbstractSyntax {
    /**
     * デフォルト・コンストラクタ.
     */
    public BlankParentheses() {
    }

    @Override
    public SyntaxPatterns getSyntaxPatterns() {
        return new SyntaxPatterns(
            new SyntaxPattern(SyntaxPattern.Pattern.NONE),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    OpenParenthesesToken.class),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    CloseParenthesesToken.class)
        );
    }
}
