package com.cch_lab.android.apply.prototype.tinybasic.syntax.item;

import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPattern;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPatterns;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.BlockCommentToken;


/**
 * ブロックコメント構文木.
 * <p>
 *     ブロックコメントを表す構文木です。
 * </p>
 */
public class BlockComment extends AbstractSyntax {
    /**
     * デフォルト・コンストラクタ.
     */
    public BlockComment() {
    }

    @Override
    public SyntaxPatterns getSyntaxPatterns() {
        return new SyntaxPatterns(
            new SyntaxPattern(SyntaxPattern.Pattern.NOT_EXIST,
                    BeginBlockComment.class,
                    MiddleBlockComment.class),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    BlockCommentToken.class),
            new SyntaxPattern(SyntaxPattern.Pattern.NONE)
        );
    }
}
