package com.cch_lab.android.apply.prototype.tinybasic.syntax.item;

import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPattern;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPatterns;


/**
 * 組込関数・構文木.
 * <p>
 *     組込関数を表す構文木です。
 * </p>
 */
public class BuiltInFunction extends AbstractSyntax {
    /**
     * デフォルト・コンストラクタ.
     */
    public BuiltInFunction() {
    }

    @Override
    public SyntaxPatterns getSyntaxPatterns() {
        return new SyntaxPatterns(
            new SyntaxPattern(SyntaxPattern.Pattern.NONE),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    InputFunction.class,
                    PrintFunction.class),
            new SyntaxPattern(SyntaxPattern.Pattern.NONE)
        );
    }
}
