package com.cch_lab.android.apply.prototype.tinybasic.syntax.item;

import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPattern;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPatterns;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.EndBlockCommentToken;


/**
 * ブロックコメント終端構文木.
 * <p>
 *     ブロックコメント終端を表す構文木です。
 * </p>
 */
public class EndBlockComment extends AbstractSyntax {
    /**
     * デフォルト・コンストラクタ.
     */
    public EndBlockComment() {
    }

    @Override
    public SyntaxPatterns getSyntaxPatterns() {
        return new SyntaxPatterns(
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    BeginBlockComment.class,
                    MiddleBlockComment.class),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    EndBlockCommentToken.class),
            new SyntaxPattern(SyntaxPattern.Pattern.NONE)
        );
    }
}
