package com.cch_lab.android.apply.prototype.tinybasic.syntax.item;

import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPattern;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPatterns;


/**
 * 演算式・構文木.
 * <p>
 *     演算式を表す構文木です。
 * </p>
 */
public class Expression extends AbstractSyntax {
    /**
     * デフォルト・コンストラクタ.
     */
    public Expression() {
    }

    @Override
    public SyntaxPatterns getSyntaxPatterns() {
        return new SyntaxPatterns(
            new SyntaxPattern(SyntaxPattern.Pattern.NONE),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    OperationValue.class,
                    OperationLeftParentheses.class,
                    OperationRightParentheses.class,
                    OperationBothParentheses.class,
                    PrimaryBinaryOperator.class,
                    SecondaryBinaryOperator.class,
                    BuiltInFunction.class),
            new SyntaxPattern(SyntaxPattern.Pattern.NONE)
        );
    }
}
