package com.cch_lab.android.apply.prototype.tinybasic.syntax.item;

import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPattern;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPatterns;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.DivideOperatorToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.EqualsOperatorToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.GreaterEqualsOperatorToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.GreaterThenOperatorToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.LessEqualsOperatorToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.LessThenOperatorToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.MultiOperatorToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.NotEqualsOperatorToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.OpenParenthesesToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.ReminderOperatorToken;


/**
 * (左丸括弧第一次)二項演算・構文木.
 * <p>
 *     (左丸括弧第一次)・二項演算を表す構文木です。
 * </p>
 */
public class LeftParenthesesBinaryOperator extends AbstractSyntax {
    /**
     * デフォルト・コンストラクタ.
     */
    public LeftParenthesesBinaryOperator() {
    }

    @Override
    public SyntaxPatterns getSyntaxPatterns() {
        return new SyntaxPatterns(
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    OperationValue.class),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    MultiOperatorToken.class,
                    DivideOperatorToken.class,
                    ReminderOperatorToken.class,
                    EqualsOperatorToken.class,
                    NotEqualsOperatorToken.class,
                    GreaterEqualsOperatorToken.class,
                    LessEqualsOperatorToken.class,
                    GreaterThenOperatorToken.class,
                    LessThenOperatorToken.class),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    OpenParenthesesToken.class)
        );
    }
}
