package com.cch_lab.android.apply.prototype.tinybasic.syntax.item;

import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPattern;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPatterns;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.LineCommentToken;


/**
 * 行コメント構文木.
 * <p>
 *     行コメントを表す構文木です。
 * </p>
 */
public class LineComment extends AbstractSyntax {
    /**
     * デフォルト・コンストラクタ.
     */
    public LineComment() {
    }

    @Override
    public SyntaxPatterns getSyntaxPatterns() {
        return new SyntaxPatterns(
            new SyntaxPattern(SyntaxPattern.Pattern.NOT_EXIST,
                    BeginBlockComment.class,
                    MiddleBlockComment.class),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    LineCommentToken.class),
            new SyntaxPattern(SyntaxPattern.Pattern.NONE)
        );
    }
}
