package com.cch_lab.android.apply.prototype.tinybasic.syntax.item;

import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPattern;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPatterns;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.MiddleBlockCommentToken;


/**
 * ブロックコメント中途構文木.
 * <p>
 *     ブロックコメント中途を表す構文木です。
 * </p>
 */
public class MiddleBlockComment extends AbstractSyntax {
    /**
     * デフォルト・コンストラクタ.
     */
    public MiddleBlockComment() {
    }

    @Override
    public SyntaxPatterns getSyntaxPatterns() {
        return new SyntaxPatterns(
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    BeginBlockComment.class,
                    MiddleBlockComment.class),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    MiddleBlockCommentToken.class),
            new SyntaxPattern(SyntaxPattern.Pattern.NONE)
        );
    }
}
