package com.cch_lab.android.apply.prototype.tinybasic.syntax.item;

import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPattern;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPatterns;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.CloseParenthesesToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.OpenParenthesesToken;


/**
 * (両丸括弧)単項演算・構文木.
 * <p>
 *     (両丸括弧)単項演算を表す構文木です。
 * </p>
 */
public class OperationBothParentheses extends AbstractSyntax {
    /**
     * デフォルト・コンストラクタ.
     */
    public OperationBothParentheses() {
    }

    @Override
    public SyntaxPatterns getSyntaxPatterns() {
        return new SyntaxPatterns(
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    OpenParenthesesToken.class),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    OperationValue.class,
                    PrimaryBinaryOperator.class,
                    SecondaryBinaryOperator.class),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    CloseParenthesesToken.class)
        );
    }
}
