package com.cch_lab.android.apply.prototype.tinybasic.syntax.item;

import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPattern;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPatterns;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.IntegerNumberLiteralToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.StringLiteralToken;


/**
 * 演算値・構文木.
 * <p>
 *     演算値を表す構文木です。
 * </p>
 */
public class OperationValue extends AbstractSyntax {
    /**
     * デフォルト・コンストラクタ.
     */
    public OperationValue() {
    }

    @Override
    public SyntaxPatterns getSyntaxPatterns() {
        return new SyntaxPatterns(
            new SyntaxPattern(SyntaxPattern.Pattern.NONE),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    IntegerNumberLiteralToken.class,
                    StringLiteralToken.class,
                    Variable.class,
                    UnaryOperator.class),
            new SyntaxPattern(SyntaxPattern.Pattern.NONE)
        );
    }
}
