package com.cch_lab.android.apply.prototype.tinybasic.syntax.item;

import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPattern;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPatterns;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxStream;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.NameToken;


/**
 * printキーワード・構文木.
 * <p>
 *     printキーワードを表す構文木です。
 * </p>
 */
public class PrintKeyword extends AbstractSyntax {
    /**
     * デフォルト・コンストラクタ.
     */
    public PrintKeyword() {
    }

    @Override
    public SyntaxPatterns getSyntaxPatterns() {
        return new SyntaxPatterns(
            new SyntaxPattern(SyntaxPattern.Pattern.NONE),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    NameToken.class),
            new SyntaxPattern(SyntaxPattern.Pattern.NONE)
        );
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean isPattern(SyntaxStream syntaxStream) {
        boolean isPattern = super.isPattern(syntaxStream);
        return isPattern &&
                "print".equals(
                        getBodySyntax().getToken()
                                .getTokenSource().getSource());
    }
}
