package com.cch_lab.android.apply.prototype.tinybasic.syntax.item;

import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPattern;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPatterns;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.MinusOperatorToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.PlusOperatorToken;


/**
 * (第二次)二項演算・構文木.
 * <p>
 *     (第二次)二項演算を表す構文木です。
 * </p>
 */
public class SecondaryBinaryOperator extends AbstractSyntax {
    /**
     * デフォルト・コンストラクタ.
     */
    public SecondaryBinaryOperator() {
    }

    @Override
    public SyntaxPatterns getSyntaxPatterns() {
        return new SyntaxPatterns(
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    OperationValue.class,
                    OperationLeftParentheses.class,
                    OperationRightParentheses.class,
                    OperationBothParentheses.class,
                    PrimaryBinaryOperator.class,
                    SecondaryBinaryOperator.class,
                    BuiltInFunction.class),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    PlusOperatorToken.class,
                    MinusOperatorToken.class),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    OperationValue.class,
                    OperationLeftParentheses.class,
                    OperationRightParentheses.class,
                    OperationBothParentheses.class,
                    PrimaryBinaryOperator.class,
                    SecondaryBinaryOperator.class,
                    BuiltInFunction.class)
        );
    }
}
