package com.cch_lab.android.apply.prototype.tinybasic.syntax.item;

import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPattern;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPatterns;


/**
 * (独立)文・構文木.
 * <p>
 *     独立した単一の文を表す構文木です。
 * </p>
 */
public class Statement extends AbstractSyntax {
    /**
     * デフォルト・コンストラクタ.
     */
    public Statement() {
    }

    @Override
    public SyntaxPatterns getSyntaxPatterns() {
        return new SyntaxPatterns(
            new SyntaxPattern(SyntaxPattern.Pattern.NONE),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    AssignmentWithDefineStatement.class,
                    AssignmentStatement.class,
                    ExpressionStatement.class),
            new SyntaxPattern(SyntaxPattern.Pattern.NONE)
        );
    }
}
