package com.cch_lab.android.apply.prototype.tinybasic.syntax.item;

import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPattern;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPatterns;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.CloseParenthesesToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.IntegerNumberLiteralToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.MinusOperatorToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.NegativeOperatorToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.PlusOperatorToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.StringLiteralToken;


/**
 * (第一次)単項演算・構文木.
 * <p>
 *     (第一次)単項演算を表す構文木です。
 * </p>
 */
public class UnaryOperator extends AbstractSyntax {
    /**
     * デフォルト・コンストラクタ.
     */
    public UnaryOperator() {
    }

    @Override
    public SyntaxPatterns getSyntaxPatterns() {
        return new SyntaxPatterns(
            new SyntaxPattern(SyntaxPattern.Pattern.NOT_EXIST,
                    IntegerNumberLiteralToken.class,
                    StringLiteralToken.class,
                    CloseParenthesesToken.class,
                    Variable.class),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    PlusOperatorToken.class,
                    MinusOperatorToken.class,
                    NegativeOperatorToken.class),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    IntegerNumberLiteralToken.class,
                    Variable.class)
        );
    }
}
