package com.cch_lab.android.apply.prototype.tinybasic.syntax.item;

import com.cch_lab.android.apply.prototype.tinybasic.syntax.AbstractSyntax;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPattern;
import com.cch_lab.android.apply.prototype.tinybasic.syntax.SyntaxPatterns;
import com.cch_lab.android.apply.prototype.tinybasic.token.item.NameToken;


/**
 * 変数・構文木.
 * <p>
 *     変数を表す構文木です。
 * </p>
 */
public class Variable extends AbstractSyntax {
    /**
     * デフォルト・コンストラクタ.
     */
    public Variable() {
    }

    @Override
    public SyntaxPatterns getSyntaxPatterns() {
        return new SyntaxPatterns(
            new SyntaxPattern(SyntaxPattern.Pattern.NONE),
            new SyntaxPattern(SyntaxPattern.Pattern.EXIST,
                    NameToken.class),
            new SyntaxPattern(SyntaxPattern.Pattern.NONE)
        );
    }
}
