package com.cch_lab.android.apply.prototype.tinybasic.token;

import java.util.ArrayList;
import java.util.List;


/**
 * トークン・ストリーム.
 * <p>
 *     トークンのストリームを表すクラスです。
 * </p>
 */
public class TokenStream {
    private List<AbstractToken> tokenStream;

    /**
     * デフォルト・コンストラクタ.
     */
    public TokenStream() {
        this.tokenStream = new ArrayList<>();
    }

    /**
     * コンストラクタ.
     * @param tokens トークン・リスト
     */
    public TokenStream(List<AbstractToken> tokens) {
        tokenStream = tokens;
    }

    /**
     * トークン・ストリーム追加.
     * @param tokens トークン・リスト
     */
    public void add(List<AbstractToken> tokens) {
        tokenStream.addAll(tokens);
    }

    /**
     * トークン・ストリーム追加.
     * @param token トークン
     */
    public void add(AbstractToken token) {
        tokenStream.add(token);
    }

    /**
     * トークン取得.
     * @param index トークン位置インデックス
     * @return トークン
     */
    public AbstractToken getToken(int index) {
        return tokenStream.get(index);
    }

    /**
     * トークン個数取得.
     * @return トークン個数
     */
    public int size() {
        return tokenStream.size();
    }
}
