package com.cch_lab.android.apply.prototype.tinybasic.token.item;

import com.cch_lab.android.apply.prototype.tinybasic.token.AbstractToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.TokenPattern;

import java.util.regex.Pattern;

/**
 * ブロックコメント始端・トークン.
 * <p>
 *     ブロックコメント始端を表すトークンです。
 * </p>
 */
public class BeginBlockCommentToken extends AbstractToken {
    /**
     * デフォルト・コンストラクタ.
     */
    public BeginBlockCommentToken() {
    }

    @Override
    public TokenPattern getTokenPattern() {
        return new TokenPattern(
                Pattern.compile("/\\*.*"),
                true,
                BeginBlockCommentToken.class, MiddleBlockCommentToken.class, EndBlockCommentToken.class);
    }
}
