package com.cch_lab.android.apply.prototype.tinybasic.token.item;

import com.cch_lab.android.apply.prototype.tinybasic.token.AbstractToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.TokenPattern;

import java.util.regex.Pattern;

/**
 * ブロックコメント終端・トークン.
 * <p>
 *     ブロックコメント終端を表すトークンです。
 * </p>
 */
public class EndBlockCommentToken extends AbstractToken {
    /**
     * デフォルト・コンストラクタ.
     */
    public EndBlockCommentToken() {
    }

    @Override
    public TokenPattern getTokenPattern() {
        return new TokenPattern(
                Pattern.compile(".*\\*/"),
                false,
                BeginBlockCommentToken.class, MiddleBlockCommentToken.class);
    }
}
