package com.cch_lab.android.apply.prototype.tinybasic.token.item;

import com.cch_lab.android.apply.prototype.tinybasic.token.AbstractToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.TokenPattern;

import java.util.regex.Pattern;

/**
 * 名称トークン.
 * <p>
 *     変数名や関数名およびキーワードを含めた不特定名称を表すトークンです。
 * </p>
 */
public class NameToken extends AbstractToken {
    /**
     * デフォルト・コンストラクタ.
     */
    public NameToken() {
    }

    @Override
    public TokenPattern getTokenPattern() {
        return new TokenPattern(Pattern.compile("[a-zA-Z_][a-zA-Z0-9_]*"), false);
    }
}
