package com.cch_lab.android.apply.prototype.tinybasic.token.item;

import com.cch_lab.android.apply.prototype.tinybasic.token.AbstractToken;
import com.cch_lab.android.apply.prototype.tinybasic.token.TokenPattern;

import java.util.regex.Pattern;

/**
 * 文字列リテラル・トークン.
 * <p>
 *     文字列リテラルを表すトークンです。
 * </p>
 */
public class StringLiteralToken extends AbstractToken {
    /**
     * デフォルト・コンストラクタ.
     */
    public StringLiteralToken() {
    }

    @Override
    public TokenPattern getTokenPattern() {
        // 当該文字列リテラル内には、エスケープシーケンスによる " を含むことができない。
        return new TokenPattern(Pattern.compile("\"[^\"]*\""), false);
    }
}
